## player 0.1.0

=== DESCRIPTION ===
Package: player
Title: Play Games in the Console
Version: 0.1.0
Authors@R: c(
    person("Alexander", "Rossell Hayes", , "alexander@rossellhayes.com", role = c("aut", "cre", "cph"),
           comment = c(ORCID = "0000-0001-9412-0457")),
    person("Alan", "Beale", , "12dicts@pobox.com", role = "dtc",
           comment = "Word lists"),
    person("Kevin", "Atkinson", , "kevina@users.sourceforge.net", role = "dtc",
           comment = "Word lists"),
    person("Luis", "Von Ahn", role = "dtc",
           comment = "Word lists"),
    person("Flavia", "Rossell Hayes", role = "ill"),
    person("Kristin", "Bott", , "kristin.bott@posit.co", role = "ctb",
           comment = "look_busy() status messages"),
    person("Daniel", "Chen", , "daniel.chen@posit.co", role = "ctb",
           comment = c(ORCID = "0000-0003-3857-1741", "look_busy() status messages")),
    person("Steven", "Smallberg", , "steven.smallberg@posit.co", role = "ctb",
           comment = "look_busy() status messages")
  )
Description: Games that can be played in the R console.  Includes coin
    flip, hangman, jumble, magic 8 ball, poker, rock paper scissors, shut
    the box, spelling bee, and 2048.
License: MIT + file LICENSE
URL: https://github.com/rossellhayes/player
BugReports: https://github.com/rossellhayes/player/issues
Depends: R (>= 3.5)
Imports: and, cli, crayon, dplyr, glue, nnet, plu, purrr, R6, rlang,
        stats, stringr, tools, twenty48 (>= 0.2.1), utils, withr
Suggests: job, rstudioapi, testthat (>= 3.0.0)
Config/testthat/edition: 3
Encoding: UTF-8
RoxygenNote: 7.3.3
NeedsCompilation: no
Packaged: 2025-09-16 14:22:54 UTC; alex
Author: Alexander Rossell Hayes [aut, cre, cph] (ORCID:
    <https://orcid.org/0000-0001-9412-0457>),
  Alan Beale [dtc] (Word lists),
  Kevin Atkinson [dtc] (Word lists),
  Luis Von Ahn [dtc] (Word lists),
  Flavia Rossell Hayes [ill],
  Kristin Bott [ctb] (look_busy() status messages),
  Daniel Chen [ctb] (ORCID: <https://orcid.org/0000-0003-3857-1741>,
    look_busy() status messages),
  Steven Smallberg [ctb] (look_busy() status messages)
Maintainer: Alexander Rossell Hayes <alexander@rossellhayes.com>
Repository: CRAN
Date/Publication: 2025-09-22 08:10:02 UTC

## player 3.0.1+dfsg

=== CMakeLists.txt ===
IF (WIN32)
    # Require 2.6 for Windows
    CMAKE_MINIMUM_REQUIRED (VERSION 2.6 FATAL_ERROR)
ELSE (WIN32)
    CMAKE_MINIMUM_REQUIRED (VERSION 2.4.7 FATAL_ERROR)
ENDIF (WIN32)

# Compatibility settings
IF (COMMAND CMAKE_POLICY)
    CMAKE_POLICY (SET CMP0003 NEW)
    CMAKE_POLICY (SET CMP0004 NEW)
ENDIF (COMMAND CMAKE_POLICY)


# Set the project name (helps Visual Studio, mainly)
PROJECT (Player)
STRING (TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)
# Set the package version
SET (PLAYER_VERSION 3.0.1 CACHE STRING "Player distribution version")
SET (PLAYER_API_VERSION 3.0 CACHE STRING "Player API version")
MESSAGE (STATUS "${PROJECT_NAME} version ${PLAYER_VERSION}")

# Set where to find our internal CMake scripts
SET (PLAYER_CMAKE_DIR ${PROJECT_SOURCE_DIR}/cmake CACHE PATH "Location of CMake scripts")
# Get version components
INCLUDE (${PLAYER_CMAKE_DIR}/internal/DissectVersion.cmake)
# Determine the operating system in detail
INCLUDE (${PLAYER_CMAKE_DIR}/internal/FindOS.cmake)

# Enable -Wall by default
IF (NOT PLAYER_OS_WIN AND NOT PLAYER_OS_SOLARIS)
    # Using -Wall on Windows causes MSVC to produce thousands of warnings in its
    # own standard headers, dramatically slowing down the build.
    SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
    SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
ENDIF (NOT PLAYER_OS_WIN AND NOT PLAYER_OS_SOLARIS)

# Check the compiler version is OK
# INCLUDE (${PLAYER_CMAKE_DIR}/internal/CheckCompiler.cmake)
# Setup directories such as install destination
INCLUDE (${PLAYER_CMAKE_DIR}/internal/SetupDirectories.cmake)
# Uninstall target
INCLUDE (${PLAYER_CMAKE_DIR}/internal/UninstallTarget.cmake)

# Some options to control the build
OPTION (PLAYER_BUILD_TESTS "Enables compilation of the test suites" ON)

# Look for various needed things
INCLUDE (${PLAYER_CMAKE_DIR}/internal/SearchForStuff.cmake)
# Give the user some compile options
INCLUDE (${PLAYER_CMAKE_DIR}/internal/GeneralCompileOptions.cmake)
# Write the config.h file
CONFIGURE_FILE (${PROJECT_SOURCE_DIR}/config.h.in ${PROJECT_BINARY_DIR}/config.h)
# Generate playerconfig.h
SET (playerconfig_h_in "${CMAKE_CURRENT_SOURCE_DIR}/playerconfig.h.in")
SET (playerconfig_h "${CMAKE_CURRENT_BINARY_DIR}/playerconfig.h")
CONFIGURE_FILE (${playerconfig_h_in} ${playerconfig_h})
INSTALL (FILES ${playerconfig_h} DESTINATION ${PLAYER_INCLUDE_INSTALL_DIR} COMPONENT headers)
# Include some useful macros
INCLUDE (${PLAYER_CMAKE_DIR}/internal/LibraryUtils.cmake)

# Set some common include directories, including the binary dir to get config.h and playerconfig.h
INCLUDE_DIRECTORIES (${PROJECT_SOURCE_DIR} ${PROJECT_BINARY_DIR} ${PROJECT_BINARY_DIR}/libplayercore)
# Extra directories where needed libraries, etc may be located (set by the user)
INCLUDE_DIRECTORIES (${PLAYER_EXTRA_INCLUDE_DIRS})
LINK_DIRECTORIES (${PLAYER_EXTRA_LIB_DIRS})

IF (PLAYER_OS_WIN)
    # This is pretty much a universal include on Windows
    INCLUDE_DIRECTORIES (${PROJECT_SOURCE_DIR}/replace)
ENDIF (PLAYER_OS_WIN)

ADD_SUBDIRECTORY (libplayercommon)
ADD_SUBDIRECTORY (libplayerinterface)
ADD_SUBDIRECTORY (client_libs)
ADD_SUBDIRECTORY (libplayercore)
ADD_SUBDIRECTORY (config)           # Example config files
ADD_SUBDIRECTORY (libplayerwkb)
ADD_SUBDIRECTORY (libplayerjpeg)
ADD_SUBDIRECTORY (libplayertcp)
ADD_SUBDIRECTORY (libplayersd)
ADD_SUBDIRECTORY (rtk2)
ADD_SUBDIRECTORY (server)
ADD_SUBDIRECTORY (examples)
ADD_SUBDIRECTORY (utils)
ADD_SUBDIRECTORY (doc)
ADD_SUBDIRECTORY (cmake)            # CMake modules for Player libraries
ADD_SUBDIRECTORY (replace)
MESSAGE (STATUS "")

PLAYER_CLEAR_CACHED_LISTS ()

# Create packages
INCLUDE (InstallRequiredSystemLibraries)
CONFIGURE_FILE ("${PROJECT_SOURCE_DIR}/PlayerCPackOptions.cmake.in" "${PROJECT_BINARY_DIR}/PlayerCPackOptions.cmake" @ONLY)
SET (CPACK_PROJECT_CONFIG_FILE "${PROJECT_BINARY_DIR}/PlayerCPackOptions.cmake")
INCLUDE (CPack)

=== config/CMakeLists.txt ===
SET (sampleConfigFiles  amigobot.cfg
                        amigobot_tcp.cfg
                        amtecM5.cfg
                        b21r_rflex_lms200.cfg
                        cvcam.cfg
                        dummy.cfg
                        erratic.cfg
                        hokuyo_aist.cfg
                        iwspy.cfg
                        joystick.cfg
                        lms400.cfg
                        magellan.cfg
                        mapfile.cfg
                        mbicp.cfg
                        nomad.cfg
                        obot.cfg
                        passthrough.cfg
                        phidgetIFK.cfg
                        phidgetRFID.cfg
                        pioneer.cfg
                        pioneer_rs4euze.cfg
                        pointcloud3d.cfg
                        readlog.cfg
                        rfid.cfg
                        roomba.cfg
                        segwayrmp.cfg
                        service_adv.cfg
                        simple.cfg
                        sphere.cfg
                        umass_ATRVJr.cfg
                        umass_ATRVMini.cfg
                        umass_reb.cfg
                        urglaser.cfg
                        vfh.cfg
                        wavefront.cfg
                        wbr914.cfg
                        writelog.cfg
                        wsn.cfg)

INSTALL (FILES ${sampleConfigFiles} DESTINATION "share/${PROJECT_NAME_LOWER}/config" COMPONENT samplecfg)

=== utils/playerv/CMakeLists.txt ===
OPTION (BUILD_UTILS_PLAYERV "Build the playerv utility" ON)
IF (BUILD_UTILS_PLAYERV)
    IF (WITH_GTK AND INCLUDE_RTK)
        SET (playervSrcs    playerv.c
                            playerv.h
                            registry.c
                            mainwnd.c
                            error.h
                            opt.c
                            opt.h
                            pv_dev_actarray.c
                            pv_dev_aio.c
                            pv_dev_blobfinder.c
                            pv_dev_camera.c
                            pv_dev_bumper.c
                            pv_dev_dio.c
                            pv_dev_fiducial.c
                            pv_dev_ir.c
                            pv_dev_laser.c
                            pv_dev_map.c
                            pv_dev_position2d.c
                            pv_dev_power.c
                            pv_dev_ptz.c
                            pv_dev_sonar.c
                            pv_dev_wifi.c
                            pv_dev_gripper.c
                            pv_dev_ranger.c
                            pv_dev_vectormap.c)

        INCLUDE_DIRECTORIES (${PROJECT_SOURCE_DIR}/client_libs ${GTK_PKG_INCLUDE_DIRS})
        LINK_DIRECTORIES (${GTK_PKG_LIBRARY_DIRS})
        PLAYER_ADD_EXECUTABLE (playerv ${playervSrcs})
        TARGET_LINK_LIBRARIES (playerv playerc playerinterface playercommon
            rtk ${PLAYERC_EXTRA_LINK_LIBRARIES} ${GTK_PKG_LIBRARIES})
        IF (PLAYER_OS_SOLARIS)
            TARGET_LINK_LIBRARIES (playerv rt)
        ENDIF (PLAYER_OS_SOLARIS)
        SET_SOURCE_FILES_PROPERTIES (${playervSrcs} PROPERTIES
            COMPILE_FLAGS "${GTK_CFLAGS}")
        SET_TARGET_PROPERTIES (playerv PROPERTIES
            LINK_FLAGS "${GTK_LINKFLAGS}")
    ELSE (WITH_GTK AND INCLUDE_RTK)
        MESSAGE (STATUS "playerv will not be built - GTK not found or RTK disabled.")
    ENDIF (WITH_GTK AND INCLUDE_RTK)
ENDIF (BUILD_UTILS_PLAYERV)

=== server/drivers/blobfinder/CMakeLists.txt ===
ADD_SUBDIRECTORY (acts)
ADD_SUBDIRECTORY (artoolkitplus)
ADD_SUBDIRECTORY (cmvision)
ADD_SUBDIRECTORY (shapetracker)
ADD_SUBDIRECTORY (simpleshape)
ADD_SUBDIRECTORY (upcbarcode)

=== server/drivers/camera/CMakeLists.txt ===
ADD_SUBDIRECTORY (v4l)
ADD_SUBDIRECTORY (v4l2)
ADD_SUBDIRECTORY (1394)
ADD_SUBDIRECTORY (camfilter)
ADD_SUBDIRECTORY (compress)
ADD_SUBDIRECTORY (cvcam)
ADD_SUBDIRECTORY (imageseq)
ADD_SUBDIRECTORY (sphere)
ADD_SUBDIRECTORY (uvc)
ADD_SUBDIRECTORY (yarp)
ADD_SUBDIRECTORY (unicap)
ADD_SUBDIRECTORY (videocanny)

=== server/drivers/opaque/CMakeLists.txt ===
PLAYERDRIVER_OPTION (flexiport build_flexiport ON)
PLAYERDRIVER_REQUIRE_PKG (flexiport build_flexiport flexiport flexiport_includeDirs
    flexiport_libDirs flexiport_linkLibs flexiport_linkFlags flexiport_cFlags 1.0.0)
PLAYERDRIVER_ADD_DRIVER (flexiport build_flexiport
    INCLUDEDIRS ${flexiport_includeDirs} LIBDIRS ${flexiport_libDirs}
    LINKLIBS ${flexiport_linkLibs} LINKFLAGS ${flexiport_linkFlags} CFLAGS ${flexiport_cFlags}
    SOURCES flexiport.cc)

PLAYERDRIVER_OPTION (serialstream build_serialstream ON)
PLAYERDRIVER_REJECT_OS (serialstream build_serialstream PLAYER_OS_WIN)
PLAYERDRIVER_ADD_DRIVER (serialstream build_serialstream SOURCES serialstream.cc)

PLAYERDRIVER_OPTION (tcpstream build_tcpstream ON)
PLAYERDRIVER_REJECT_OS (tcpstream build_tcpstream PLAYER_OS_WIN)
PLAYERDRIVER_ADD_DRIVER (tcpstream build_tcpstream SOURCES tcpstream.cc)

=== server/drivers/position/CMakeLists.txt ===
ADD_SUBDIRECTORY (ascension)
ADD_SUBDIRECTORY (bumpersafe)
ADD_SUBDIRECTORY (deadstop)
ADD_SUBDIRECTORY (globalize)
ADD_SUBDIRECTORY (goto)
ADD_SUBDIRECTORY (isense)
ADD_SUBDIRECTORY (lasersafe)
ADD_SUBDIRECTORY (mbicp)
ADD_SUBDIRECTORY (microstrain)
ADD_SUBDIRECTORY (motionmind)
ADD_SUBDIRECTORY (nav200)
ADD_SUBDIRECTORY (nd)
ADD_SUBDIRECTORY (segwayrmp400)
ADD_SUBDIRECTORY (snd)
ADD_SUBDIRECTORY (roboteq)
ADD_SUBDIRECTORY (vfh)

=== server/drivers/shell/CMakeLists.txt ===
PLAYERDRIVER_OPTION (cmdsplitter build_cmdsplitter ON)
PLAYERDRIVER_ADD_DRIVER (cmdsplitter build_cmdsplitter SOURCES cmdsplitter.cc)

PLAYERDRIVER_OPTION (diocmd build_diocmd ON)
PLAYERDRIVER_ADD_DRIVER (diocmd build_diocmd SOURCES diocmd.cc)

PLAYERDRIVER_OPTION (dummy build_dummy ON)
PLAYERDRIVER_ADD_DRIVER (dummy build_dummy SOURCES dummy.cc)

PLAYERDRIVER_OPTION (gripcmd build_gripcmd ON)
PLAYERDRIVER_ADD_DRIVER (gripcmd build_gripcmd SOURCES gripcmd.cc)

PLAYERDRIVER_OPTION (inhibitor build_inhibitor ON)
PLAYERDRIVER_ADD_DRIVER (inhibitor build_inhibitor SOURCES inhibitor.cc)

IF (HAVE_STL)
    PLAYERDRIVER_OPTION (kartowriter build_kartowriter ON)
ELSE (HAVE_STL)
    PLAYERDRIVER_OPTION (kartowriter build_kartowriter OFF "STL not found.")
ENDIF (HAVE_STL)
PLAYERDRIVER_ADD_DRIVER (kartowriter build_kartowriter SOURCES kartowriter.cc)

PLAYERDRIVER_OPTION (writelog build_writelog ON)
PLAYERDRIVER_ADD_DRIVER (writelog build_writelog SOURCES writelog.cc encode.cc)

PLAYERDRIVER_OPTION (readlog build_readlog ON)
IF (HAVE_Z)
    SET (readlogLinkFlags -lz)
ENDIF (HAVE_Z)
PLAYERDRIVER_ADD_DRIVER (readlog build_readlog SOURCES encode.cc readlog_time.cc readlog.cc
                        LINKFLAGS ${readlogLinkFlags})

PLAYERDRIVER_OPTION (passthrough build_passthrough ON)
PLAYERDRIVER_ADD_DRIVER (passthrough build_passthrough SOURCES passthrough.cc)

PLAYERDRIVER_OPTION (relay build_relay ON)
PLAYERDRIVER_ADD_DRIVER (relay build_relay SOURCES relay.cc)

PLAYERDRIVER_OPTION (suppressor build_suppressor ON)
PLAYERDRIVER_ADD_DRIVER (suppressor build_suppressor SOURCES suppressor.cc)

PLAYERDRIVER_OPTION (velcmd build_velcmd ON)
PLAYERDRIVER_ADD_DRIVER (velcmd build_velcmd SOURCES velcmd.cc)

=== client_libs/libplayerc++/bindings/python/CMakeLists.txt ===
INCLUDE (FindPythonInterp)

IF(BUILD_PLAYERCC)
    IF (PYTHONINTERP_FOUND)
        OPTION (BUILD_PYTHONCPP_BINDINGS "Build the Python bindings for the C++ client library" OFF)

        IF (BUILD_PYTHONCPP_BINDINGS)
            FIND_PACKAGE (SWIG)
            IF (SWIG_FOUND)
                MESSAGE (STATUS "Python bindings for C++ client library will be built")

                #INCLUDE (${SWIG_USE_FILE})
                INCLUDE (${PLAYER_CMAKE_DIR}/internal/UseSwig_Player.cmake)

                FIND_PACKAGE (PythonLibs)
                INCLUDE_DIRECTORIES (${PYTHON_INCLUDE_PATH})
                INCLUDE_DIRECTORIES (${PROJECT_BINARY_DIR})
                INCLUDE_DIRECTORIES (${PROJECT_BINARY_DIR}/client_libs)
                INCLUDE_DIRECTORIES (${PROJECT_SOURCE_DIR})
                INCLUDE_DIRECTORIES (${PROJECT_SOURCE_DIR}/client_libs)

                # Use playercpp.i from source directory
                SET (playercpp_i "${CMAKE_CURRENT_SOURCE_DIR}/playercpp.i")

                SET_SOURCE_FILES_PROPERTIES(${playercpp_i} PROPERTIES CPLUSPLUS ON)

                SET (SWIG_MODULE_playercpppy_EXTRA_DEPS ${PROJECT_SOURCE_DIR}/client_libs/libplayerc++/playerc++.h)
                SWIG_ADD_MODULE (playercpppy python ${playercpp_i})
                SWIG_LINK_LIBRARIES (playercpppy ${PYTHON_LIBRARIES} playerc++)

                IF (PYTHON_OS_WIN)
                    GET_FILENAME_COMPONENT (playercpyInstallDir ${PYTHON_EXECUTABLE} PATH)
                ELSE (PYTHON_OS_WIN)
                    # Get the Python version
                    EXECUTE_PROCESS (COMMAND ${PYTHON_EXECUTABLE} -V
                                    ERROR_VARIABLE pythonVersionString
                                    ERROR_STRIP_TRAILING_WHITESPACE)
                    STRING (REGEX REPLACE "^Python ([0-9]+\\.[0-9]+).*" "\\1" pythonVersion ${pythonVersionString})
                    SET (playercpppyInstallDir ${PLAYER_LIBRARY_INSTALL_DIR}/python${pythonVersion}/site-packages)
                ENDIF (PYTHON_OS_WIN)
                SET (PYTHON_BINDINGS_INSTALL_DIR ${playercpppyInstallDir} CACHE PATH "Python bindings installation directory under $prefix")
                MARK_AS_ADVANCED (PYTHON_BINDINGS_INSTALL_DIR)

                INSTALL (FILES ${CMAKE_CURRENT_BINARY_DIR}/playercpppy.py
                        ${CMAKE_CURRENT_BINARY_DIR}/_playercpppy.so
                        DESTINATION ${PYTHON_BINDINGS_INSTALL_DIR})
            ELSE (SWIG_FOUND)
                MESSAGE (STATUS "Python bindings for C++ client library will not be built - could not find Swig")
            ENDIF (SWIG_FOUND)
        ELSE (BUILD_PYTHONCPP_BINDINGS)
            MESSAGE (STATUS "Python bindings for C++ client library will not be built - disabled by user")
        ENDIF (BUILD_PYTHONCPP_BINDINGS)
    ELSE (PYTHONINTERP_FOUND)
        MESSAGE (STATUS "Python bindings for C++ client library will not be built - could not find Python")
    ENDIF (PYTHONINTERP_FOUND)
ELSE (BUILD_PLAYERCC)
  MESSAGE (STATUS "Python bindings for C++ client library will not be built - playerc++ client library disabled")
ENDIF (BUILD_PLAYERCC)

=== client_libs/libplayerc++/bindings/ruby/CMakeLists.txt ===
FIND_PACKAGE (Ruby)

IF (RUBY_LIBRARY AND RUBY_INCLUDE_PATH)
    SET (RUBY_FOUND TRUE)
ENDIF (RUBY_LIBRARY AND RUBY_INCLUDE_PATH)

IF(BUILD_PLAYERCC)
    IF(RUBY_FOUND)
        OPTION (BUILD_RUBY_CPP_BINDINGS "Build the Ruby bindings for the C++ client library" ON)

        IF (BUILD_RUBY_CPP_BINDINGS)
            FIND_PACKAGE (SWIG)
            IF (SWIG_FOUND)
                MESSAGE (STATUS "Ruby bindings for C++ client library will be built")

                INCLUDE (${PLAYER_CMAKE_DIR}/internal/UseSwig_Player.cmake)

                INCLUDE_DIRECTORIES (${RUBY_INCLUDE_PATH})
                INCLUDE_DIRECTORIES (${PROJECT_SOURCE_DIR})
                INCLUDE_DIRECTORIES (${PROJECT_BINARY_DIR})
                INCLUDE_DIRECTORIES (${PROJECT_SOURCE_DIR}/client_libs)
                INCLUDE_DIRECTORIES (${PROJECT_BINARY_DIR}/client_libs)

                SET (CMAKE_SWIG_FLAGS "-w801")

                SET (playercpp_ruby_i "${CMAKE_CURRENT_SOURCE_DIR}/playercpp.i")
                SET_SOURCE_FILES_PROPERTIES (${playercpp_ruby_i} PROPERTIES CPLUSPLUS ON)

                SET (SWIG_MODULE_playercppr_EXTRA_DEPS ${PROJECT_SOURCE_DIR}/client_libs/libplayerc++/playerc++.h)
                SWIG_ADD_MODULE (playercppr ruby ${playercpp_ruby_i})
                SWIG_LINK_LIBRARIES (playercppr ${RUBY_LIBRARY} playerc++)

                # TODO: find ruby in windows, check install dir is correct  
                STRING(REPLACE "/usr/" "" ruby_relative_sitelib_dir ${RUBY_SITELIB_DIR})
                STRING(REPLACE "/opt/" "" ruby_relative_sitelib_dir ${ruby_relative_sitelib_dir})
                STRING(REPLACE "local/" "" ruby_relative_sitelib_dir ${ruby_relative_sitelib_dir})
                STRING(REPLACE "lib/" ${PLAYER_LIBRARY_INSTALL_DIR}/ ruby_relative_sitelib_dir ${ruby_relative_sitelib_dir})
                SET (RUBY_BINDINGS_INSTALL_DIR ${ruby_relative_sitelib_dir} CACHE PATH "Ruby bindings for the c++ library installation directory under $RUBY_SITELIB_DIR")
                MARK_AS_ADVANCED (RUBY_BINDINGS_INSTALL_DIR)

                INSTALL (FILES ${CMAKE_CURRENT_BINARY_DIR}/playercppr.so
                    DESTINATION ${RUBY_BINDINGS_INSTALL_DIR}
                    RENAME playercpp.so)
            ELSE (SWIG_FOUND)
                MESSAGE (STATUS "Ruby bindings for C++ client library will not be built - could not find Swig")
            ENDIF (SWIG_FOUND)
        ELSE (BUILD_RUBY_CPP_BINDINGS)
            MESSAGE (STATUS "Ruby bindings for C++ client library will not be built - disabled by user")
        ENDIF (BUILD_RUBY_CPP_BINDINGS)
    ELSE (RUBY_FOUND)
        MESSAGE (STATUS "Ruby bindings for C++ client library will not be built - could not find Ruby")
    ENDIF (RUBY_FOUND)
ELSE (BUILD_PLAYERCC)
  MESSAGE (STATUS "Ruby bindings for C++ client library will not be built - playerc++ client library disabled")
ENDIF (BUILD_PLAYERCC)

=== client_libs/libplayerc/bindings/ruby/CMakeLists.txt ===
FIND_PACKAGE (Ruby)

IF (RUBY_LIBRARY AND RUBY_INCLUDE_PATH)
    SET (RUBY_FOUND TRUE)
ENDIF (RUBY_LIBRARY AND RUBY_INCLUDE_PATH)

IF(RUBY_FOUND)
    OPTION (BUILD_RUBY_BINDINGS "Build the Ruby bindings for the C client library" ON)

    IF (BUILD_RUBY_BINDINGS)
        FIND_PACKAGE (SWIG)
        IF (SWIG_FOUND)
            MESSAGE (STATUS "Ruby bindings for C client library will be built")

            #INCLUDE (${SWIG_USE_FILE})
            INCLUDE (${PLAYER_CMAKE_DIR}/internal/UseSwig_Player.cmake)

            INCLUDE_DIRECTORIES (${RUBY_INCLUDE_PATH})
            INCLUDE_DIRECTORIES (${PROJECT_SOURCE_DIR})
            INCLUDE_DIRECTORIES (${PROJECT_BINARY_DIR})
            INCLUDE_DIRECTORIES (${PROJECT_SOURCE_DIR}/client_libs/libplayerc)

            SET (CMAKE_SWIG_FLAGS "-w801")

            # Generate playerc_wrap.i and playerc_wrap.h from playerc.h
            SET (playerc_wrap_prefix "${CMAKE_CURRENT_BINARY_DIR}/playerc_wrap")
            ADD_CUSTOM_COMMAND (OUTPUT "${playerc_wrap_prefix}.i"
                COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../python/playerc_swig_parse.py ${PROJECT_SOURCE_DIR}/client_libs/libplayerc/playerc.h ${playerc_wrap_prefix}
                WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                VERBATIM)

            ADD_CUSTOM_COMMAND(OUTPUT "${playerc_wrap_prefix}.h"
                DEPENDS "${playerc_wrap_prefix}.i")

            # Empty target to ensure playerc_wrap.i and playerc_wrap.h get created
            ADD_CUSTOM_TARGET (playerc_wrap_ri_target ALL
                DEPENDS "${playerc_wrap_prefix}.i"
                DEPENDS "${playerc_wrap_prefix}.h")

            SET (playerc_i "${CMAKE_CURRENT_SOURCE_DIR}/playerc.i")

            #If playercr is called simply playerc, all sorts of errors happen
            #I guess is namespace conflict with Python bindings' playerc
            #currently we create playercr locally but install it as playerc 
            SET (SWIG_MODULE_playercr_EXTRA_DEPS ${PROJECT_SOURCE_DIR}/client_libs/libplayerc/playerc.h
                                                 ${PROJECT_BINARY_DIR}/libplayerinterface/player_interfaces.h)
            SWIG_ADD_MODULE (playercr ruby ${playerc_i})
            SWIG_LINK_LIBRARIES (playercr ${RUBY_LIBRARY})
            ADD_DEPENDENCIES (${SWIG_MODULE_playercr_REAL_NAME} playerc_wrap_i_target)
            TARGET_LINK_LIBRARIES (${SWIG_MODULE_playercr_REAL_NAME} playerinterface playerc playercommon playerwkb)
            IF (HAVE_JPEG)
                TARGET_LINK_LIBRARIES (${SWIG_MODULE_playercr_REAL_NAME} playerjpeg)
            ENDIF (HAVE_JPEG)

            #TODO: find ruby in windows, check install dir is correct  
            STRING(REPLACE "/usr/" "" ruby_relative_sitelib_dir ${RUBY_SITELIB_DIR})
            STRING(REPLACE "/opt/" "" ruby_relative_sitelib_dir ${ruby_relative_sitelib_dir})
            STRING(REPLACE "local/" "" ruby_relative_sitelib_dir ${ruby_relative_sitelib_dir})
	        STRING(REPLACE "lib/" ${PLAYER_LIBRARY_INSTALL_DIR}/ ruby_relative_sitelib_dir ${ruby_relative_sitelib_dir} )
            SET (RUBY_BINDINGS_INSTALL_DIR ${ruby_relative_sitelib_dir} CACHE PATH "Ruby bindings installation directory under $RUBY_SITELIB_DIR")
            MARK_AS_ADVANCED (RUBY_BINDINGS_INSTALL_DIR)

            INSTALL (FILES ${CMAKE_CURRENT_BINARY_DIR}/playercr.so
                DESTINATION ${RUBY_BINDINGS_INSTALL_DIR}
                RENAME playerc.so)
            MESSAGE (STATUS "Ruby bindings for C client will be installed to ${RUBY_BINDINGS_INSTALL_DIR}")
        ELSE (SWIG_FOUND)
            MESSAGE (STATUS "Ruby bindings for C client library will not be built - could not find Swig")
        ENDIF (SWIG_FOUND)
    ELSE (BUILD_RUBY_BINDINGS)
        MESSAGE (STATUS "Ruby bindings for C client library will not be built - disabled by user")
    ENDIF (BUILD_RUBY_BINDINGS)
ELSE (RUBY_FOUND)
    MESSAGE (STATUS "Ruby bindings for C client library will not be built - could not find Ruby")
ENDIF (RUBY_FOUND)

=== server/drivers/dio/portio/CMakeLists.txt ===
PLAYERDRIVER_OPTION (portio build_portio ON)
PLAYERDRIVER_REJECT_OS (portio build_portio PLAYER_OS_WIN)
IF (PLAYER_OS_QNX)
    PLAYERDRIVER_REQUIRE_HEADER (portio build_portio hw/inout.h)
ELSE (PLAYER_OS_QNX)
    PLAYERDRIVER_REQUIRE_HEADER (portio build_portio sys/io.h)
ENDIF (PLAYER_OS_QNX)
PLAYERDRIVER_ADD_DRIVER (portio build_portio SOURCES portio.cc)

=== debian/changelog ===
player (3.0.1+dfsg-1.1ubuntu3) maverick; urgency=low

  * libplayercommon3.0-dev.install: added headers in libplayercommon as they
    are required for some headers in libplayercore3.0-dev package

 -- Fabrice Coutadeur <fabricesp@ubuntu.com>  Sun, 26 Sep 2010 14:09:04 +0200

player (3.0.1+dfsg-1.1ubuntu2) maverick; urgency=low

  * libplayerc3.0-dev: Install playerconfig.h. LP: #629416.
  * Fix build failure on armel, patch from Daniel Hess, taken from the Debian
    bug tracker:

  * Fix FTBS on armel, alpha and ia64 by using non-paused port io operations
    instead of the “_p” onces not defined on this architectures
    (fix-portio.patch).
  * Fix FTBS on mips and mipsel by removing zero initializer from 'struct
    sigaction' variables. 'struct sigaction' is defined different on mips and
    mipsel and the variables are set directly after declaration anyway.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 24 Sep 2010 18:14:44 +0200

player (3.0.1+dfsg-1.1ubuntu1) maverick; urgency=low

  * Merge from Debian unstable, remaining Ubuntu changes:
    + debian/control: fix opencv build-depends to require version 2 or newer.
    + debian/python-playerc.install: changed site-package to dist-package 
      (transition to python2.6).
  * debian/control: drop libphidgets-dev from build-deps (removed from archive)
  * debian/patches/python-binding-path: added to install python bindings in
    dist-package.

 -- Andrea Colangelo <warp10@ubuntu.com>  Tue, 11 Aug 2010 12:44:06 +0200

player (3.0.1+dfsg-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Add cmake build-dependency (Closes: #578785)

 -- Christoph Egger <christoph@debian.org>  Sat, 22 May 2010 11:46:13 +0200

player (3.0.1+dfsg-1) unstable; urgency=low

  * New upstream version. Closes: #528653, #487395.
    - Clean up sources to remove files that we aren't using
      in Debian and are not DFSG, and unlabeled ones we also 
      aren't using
  * Ack patch from Daniel Hess. Closes: #494713
    - Fix typo in package description.
    - Add man pages for installed binaries
    - Stronger dependencies betwen libplayer*-dev and libplayer*
  * Standards-Version to 3.8.4: No changes needed
  * Add and remove packages for new and removed / renamed libraries

 -- Michael Janssen <jamuraa@debian.org>  Tue, 30 Mar 2010 18:41:22 -0500

player (2.1.2-1) unstable; urgency=low

  * New upstream version. Closes: #528653, #487395.
  * Ack patches from Daniel Hess - changes are incorporaed. Closes: #494713.
    - Update package names in Build-Depends. 
    - Fix typo in package description.
    - Add man pages for installed binaries.
    - Tighten depends between libplayer*-dev and libplayer* packages by
      including exact version.
    - Reflect changes to *.pc files in the corresponding libplayer*-dev
      packages.
  * Add packages for libplayerutils2, libplayerutils2-dev, 
    libplayerudp2, libplayerudp2-dev.
  * Use dpatch. 
  * Standards-Version to 3.8.1.

 -- Michael Janssen <jamuraa@debian.org>  Tue, 02 Jun 2009 22:06:37 -0500

player (2.0.4-4) unstable; urgency=low

  * Fix #includes for GCC 4.3. Closes: #456063.
  * Standards-Version bump to 3.7.3

 -- Michael Janssen <jamuraa@debian.org>  Thu, 28 Feb 2008 12:11:03 -0600

player (2.0.4-3.3ubuntu6) maverick; urgency=low

  * Rebuild against new opencv soname.

 -- Lionel Le Folgoc <mrpouit@ubuntu.com>  Tue, 10 Aug 2010 00:13:37 +0200

player (2.0.4-3.3ubuntu5) lucid; urgency=low

  * Fix opencv build-depends to require version 2 or newer

 -- Luka Renko <lure@ubuntu.com>  Tue, 22 Dec 2009 23:59:32 +0100

player (2.0.4-3.3ubuntu4) lucid; urgency=low

  * Library transition for opencv 2.0
    - add build-depend on libcvaux-dev
  * debian/patches/gcc_const_char_fix.patch: fix build with 
    more strict gcc

 -- Luka Renko <lure@ubuntu.com>  Sun, 20 Dec 2009 19:11:17 +0100

player (2.0.4-3.3ubuntu3) jaunty; urgency=low

  * debian/python-playerc.install: changed site-package to dist-package 
    (transition to python2.6) (LP: #344487)
  * debian/control: add build dependency on quilt
  * debian/rules: add include of quilt's makefile and targets
  * debian/patches/python2.6_transition.patch: update Makefile.in to add 
    --install-layout=deb parameter to setup.py call

 -- Fabrice Coutadeur <coutadeurf@gmail.com>  Tue, 17 Mar 2009 19:50:29 +0000

player (2.0.4-3.3ubuntu2) jaunty; urgency=low

  * Add libvorbis-dev and libtheora-dev to build-depends, fix FTBFS.

 -- Luca Falavigna <dktrkranz@ubuntu.com>  Tue, 11 Nov 2008 23:44:26 +0100

player (2.0.4-3.3ubuntu1) jaunty; urgency=low

  * Merge from Debian unstable, remaining Ubuntu changes:
    - (Build-)depend on libdc1394-22-dev | libdc1394-dev

 -- Luca Falavigna <dktrkranz@ubuntu.com>  Tue, 11 Nov 2008 18:32:26 +0100

layer (2.0.4-3.2ubuntu2) intrepid; urgency=low

  * (Build-)dependency must be libdc1394-22-dev instead.

 -- Luca Falavigna <dktrkranz@ubuntu.com>  Sat, 20 Sep 2008 15:19:52 +0200

player (2.0.4-3.2ubuntu1) intrepid; urgency=low

  * (Build-)depend on libdc1394-dev instead of libdc1394-13-dev.

 -- Luca Falavigna <dktrkranz@ubuntu.com>  Sat, 20 Sep 2008 14:13:22 +0200

player (2.0.4-3) unstable; urgency=low

  * Add player-pmaptest to the set of utilities installed. (closes: #444257)
  * Stop working around python-central bugs that are fixed. (closes: #432740)
  * Move Homepage to real field in control file. 

 -- Michael Janssen <jamuraa@debian.org>  Tue, 27 Nov 2007 00:12:14 -0600

player (2.0.4-2) unstable; urgency=low

  * Depends update in order to depend on libgsl0dbl.

 -- Michael Janssen <jamuraa@debian.org>  Mon, 20 Aug 2007 21:40:08 -0500

player (2.0.4-1) unstable; urgency=low

  * Initial release. Closes: #282022.

 -- Michael Janssen <jamuraa@debian.org>  Thu, 17 May 2007 01:46:48 -0500

=== debian/control ===
Source: player
Section: science
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Michael Janssen <jamuraa@debian.org>
Build-Depends: debhelper (>= 7.0.50~), autotools-dev, libmagick++-dev, libgsl0-dev, libcv-dev (>= 2), libhighgui-dev (>= 2), libcvaux-dev (>= 2), libgtk2.0-dev, libdc1394-22-dev, libboost-signals-dev, libboost-thread-dev, swig, libjpeg-dev, python-central (>= 0.5), doxygen, linux-libc-dev | linux-kernel-headers, libgnomecanvas2-dev, python-dev, freeglut3-dev, graphviz, ruby, ruby-dev, libtheora-dev, libgeos-dev, libpqxx-dev, libxmu-dev, libasound2-dev, libstatgrab-dev, cmake
XS-Python-Version: all
Standards-Version: 3.8.4
Homepage: http://playerstage.sourceforge.net/

Package: robot-player
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Networked server for robots and sensors
 Provides a network interface to a variety of robot and sensor
 hardware.  Player's client/server model allows robot control programs
 to be written in any programming language and to run on any computer 
 with a network connection to th e robot. Player supports multiple 
 concurrent client connections to devices, creating new possibilities 
 for distributed and collaborative sensing and control.
 .
 Player supports a wide variety of mobile robots and accessories.

Package: robot-player-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Networked server for robots and sensors (documentation)
 Player provides a common interface to a variety of robot and 
 sensor hardware.  The client/server model allows robot programs to be
 written in many programming languages.  This package provides the
 Doxygen documentation for robot-player, libplayercore, libplayerc++, 
 libplayerc, libplayerdrivers, libplayercommon, libplayertcp, 
 libplayerinterface, libplayerwkb, and libplayerudp.

Package: robot-player-dev
Architecture: all
Depends: libplayertcp3.0-dev (>= ${source:Version}), libplayerc++3.0-dev (>= ${source:Version}), libplayerdrivers3.0-dev (>= ${source:Version}), libplayerwkb3.0-dev (>= ${source:Version}), ${misc:Depends}
Description: Networked server for robots and sensors - development package
 Player proovides a common interface to a variety of robot and}
 sensor hardware.  The client/server model allows robot programs to be
 written in many programming languages.  This metapackage provides an easy way
 to install all the development libraries at once by depending on them.

Package: libplayercommon3.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Networked server for robots and sensors - common functions
 Provides a network interface to a variety of robot and sensor
 hardware.  Player's client/server model allows robot control programs
 to be written in any programming language and to run on any computer 
 with a network connection to the robot. Player supports multiple 
 concurrent client connections to devices, creating new possibilities 
 for distributed and collaborative sensing and control.
 .
 This package contains shared functions for log and error handling.

Package: libplayercommon3.0-dev
Provides: libplayercommon-dev
Conflicts: libplayercommon-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libplayercommon3.0 (= ${binary:Version})
Description: Networked server for robots and sensors - error handling development files
 Provides a network interface to a variety of robot and sensor
 hardware.  Player's client/server model allows robot control programs
 to be written in any programming language and to run on any computer 
 with a network connection to th e robot. Player supports multiple 
 concurrent client connections to devices, creating new possibilities 
 for distributed and collaborative sensing and control.
 .
 This package contains the development files for error handling.


Package: libplayercore3.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Networked server for robots and sensors - core library
 Provides a network interface to a variety of robot and sensor
 hardware.  Player's client/server model allows robot control programs
 to be written in any programming language and to run on any computer 
 with a network connection to th e robot. Player supports multiple 
 concurrent client connections to devices, creating new possibilities 
 for distributed and collaborative sensing and control.
 .
 This package contains the shared library bridging the gap between the
 devices supported by Player and the interfaces which are defined, including
 the messages and queues in which messages are stored.

Package: libplayercore3.0-dev
Provides: libplayercore-dev, libplayercore2-dev
Conflicts: libplayercore-dev, libplayercore2-dev
Replaces: libplayercore2-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libplayercore3.0 (= ${binary:Version}), libplayercommon3.0-dev (= ${binary:Version}), libplayerinterface3.0-dev (= ${binary:Version}), libgeos-dev
Description: Networked server for robots and sensors - core library development files
 Provides a network interface to a variety of robot and sensor
 hardware.  Player's client/server model allows robot control programs
 to be written in any programming language and to run on any computer 
 with a network connection to th e robot. Player supports multiple 
 concurrent client connections to devices, creating new possibilities 
 for distributed and collaborative sensing and control.
 .
 This package contains the development files for utilizing the 
 library bridging the gap between the devices supported by Player and the
 interfaces which are defined, including the messages and queues in which
 messages are stored.

Package: libplayertcp3.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Networked server for robots and sensors - tcp library
 Provides a network interface to a variety of robot and sensor
 hardware.  Player's client/server model allows robot control programs
 to be written in any programming language and to run on any computer 
 with a network connection to th e robot. Player supports multiple 
 concurrent client connections to devices, creating new possibilities 
 for distributed and collaborative sensing and control.
 .
 This package contains the library which moves messages from Player
 message queues to the TCP socket, and vice-versa.

Package: libplayertcp3.0-dev
Provides: libplayertcp-dev, libplayertcp2-dev, libplayerudp-dev, libplayerudp2-dev
Conflicts: libplayertcp-dev, libplayertcp2-dev, libplayerudp-dev, libplayerudp2-dev
Replaces: libplayertcp2-dev, libplayerudp2-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libplayertcp3.0 (= ${binary:Version}), libplayercore3.0-dev (= ${binary:Version}), libplayerinterface3.0-dev (= ${binary:Version})
Description: Networked server for robots and sensors - tcp library development files
 Provides a network interface to a variety of robot and sensor
 hardware.  Player's client/server model allows robot control programs
 to be written in any programming language and to run on any computer 
 with a network connection to th e robot. Player supports multiple 
 concurrent client connections to devices, creating new possibilities 
 for distributed and collaborative sensing and control.
 .
 This package contains the development files for using the library which moves
 messages from Player message queues to the TCP socket, and vice-versa.

Package: libplayerc3.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Networked server for robots and sensors - C client library
 Provides a network interface to a variety of robot and sensor
 hardware.  Player's client/server model allows robot control programs
 to be written in any programming language and to run on any computer 
 with a network connection to th e robot. Player supports multiple 
 concurrent client connections to devices, creating new possibilities 
 for distributed and collaborative sensing and control.
 .
 This package contains the C library for interface to Player servers.

Package: libplayerc3.0-dev
Provides: libplayerc-dev, libplayerc2-dev
Conflicts: libplayerc-dev, libplayerc2-dev
Replaces: libplayerc2-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libplayerc3.0 (= ${binary:Version}), libplayercommon3.0-dev (= ${binary:Version})
Description: Networked server for robots and sensors - C client library development files
 Provides a network interface to a variety of robot and sensor
 hardware.  Player's client/server model allows robot control programs
 to be written in any programming language and to run on any computer 
 with a network connection to th e robot. Player supports multiple 
 concurrent client connections to devices, creating new possibilities 
 for distributed and collaborative sensing and control.
 .
 This package contains the files required to utilize the C client library

Package: libplayerc++3.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Networked server for robots and sensors - C++ client library
 Provides a network interface to a variety of robot and sensor
 hardware.  Player's client/server model allows robot control programs
 to be written in any programming language and to run on any computer 
 with a network connection to th e robot. Player supports multiple 
 concurrent client connections to devices, creating new possibilities 
 for distributed and collaborative sensing and control.
 .
 This package contains the C++ library for interface to Player servers.

Package: libplayerc++3.0-dev
Provides: libplayerc++-dev, libplayerc++2-dev
Conflicts: libplayerc++-dev, libplayerc++2-dev
Replaces: libplayerc++2-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libplayerc++3.0 (= ${binary:Version}), libplayerc3.0-dev (= ${binary:Version}), libplayercommon3.0-dev (= ${binary:Version}), libboost-thread-dev, libboost-signals-dev
Description: Networked server for robots and sensors - C++ client library development files
 Provides a network interface to a variety of robot and sensor
 hardware.  Player's client/server model allows robot control programs
 to be written in any programming language and to run on any computer 
 with a network connection to th e robot. Player supports multiple 
 concurrent client connections to devices, creating new possibilities 
 for distributed and collaborative sensing and control.
 .
 This package contains the files required to utilize the C++ client library

Package: libplayerdrivers3.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Networked server for robots and sensors - hardware drivers library
 Provides a network interface to a variety of robot and sensor
 hardware.  Player's client/server model allows robot control programs
 to be written in any programming language and to run on any computer 
 with a network connection to th e robot. Player supports multiple 
 concurrent client connections to devices, creating new possibilities 
 for distributed and collaborative sensing and control.
 .
 This package contains drivers required to run hardware available through
 the Player server.

Package: libplayerdrivers3.0-dev
Provides: libplayerdrivers-dev, libplayerdrivers2-dev
Conflicts: libplayerdrivers-dev, libplayerdrivers2-dev
Replaces: libplayerdrivers2-dev
Section: libdevel
Architecture: any

=== debian/rules ===
#!/usr/bin/make -f 

RENAMED_BINARIES=player playerv playercam playerjoy playernav playerprint playervcr playerwritemap pmaptest

%: 
	dh $@

override_dh_clean:
	dh_clean
	# for some reason, the build makes this file in the main source
	rm -f doc/player.tag

override_dh_install:
	for i in $(RENAMED_BINARIES); do mv -v debian/tmp/usr/bin/$$i debian/tmp/usr/bin/robot-$$i; done
	install -d debian/tmp/usr/share/doc/player
	mv -f debian/tmp/usr/share/doc/player-3.0.1 debian/tmp/usr/share/doc/player/html
	dh_install

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_RPATH=TRUE -DBUILD_DOCUMENTATION=TRUE

override_dh_auto_build:
	dh_auto_build
	# docs don't get built automatically
	(cd obj-$(DEB_BUILD_GNU_TYPE) && make doc)
